#AutoIt3Wrapper_Icon=sources\AppDirector.ico
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs
	Created By:
	Jochen Bierbauer (jbierbauer@gmx.de)

	Features:
	With this application you are able to
	1) Manage your scripts/batch files - have them at one point.
	2) Start these script(s)
	  2.1) adhoc at the computer you are on actually
	  2.2) generate Jobs, which are started from the computers in your network by a domain-startup-job

	License:
	Copyright (C) 2014 Jochen Bierbauer

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
#ce

#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GUIListBox.au3>
#include <GuiListView.au3>
#include <StaticConstants.au3>
#include <TabConstants.au3>
#include <WindowsConstants.au3>
#include <ListViewConstants.au3>
#include <File.au3>
#include <Array.au3>
#include <Constants.au3>
#include <MsgBoxConstants.au3>

Const $VERSION = "0.10.1"
Const $INIFILE = @ScriptDir & "\settings.ini"
Const $PATH_PACKETS = @ScriptDir & "\packets"
Const $PATH_JOBS = @ScriptDir & "\jobs"
Const $PATH_LOGS = @ScriptDir & "\logs"
Const $COPYRIGHT = " 2014 Jochen Bierbauer"

Global Const $LV_ALTERNATE_COLOR = 0xF5F5F5

Global $FormMain, $FormComputer
Global $arrPacketsAvailable
Global $arrComputersAvailable
Global $ComboComputerGroup, $ButtonComputerGroupNew, $ButtonComputerGroupSave, $ButtonComputerGroupDelete
Global $ButtonComputerSelect, $ButtonComputerSelectAll, $ButtonComputerDeSelect, $ButtonComputerDeSelectAll
Global $ButtonComputerNew, $ButtonComputerDelete, $ButtonComputerNetworkScan
Global $ListComputersAvailable, $ListComputersSelected
Global $ButtonComputerAbbrechen, $ButtonComputerCreateJobs


GUIRegisterMsg($WM_NOTIFY, "WM_Notify_Events")

;---------------------------------------------
; Form
;---------------------------------------------
#Region ### START Koda GUI section ### Form=Form1.kxf
$FormMain = GUICreate("AppDirector " & $VERSION , 623, 595, 194, 125)
GUISetFont(10, 400, 0, "MS Sans Serif")
$ButtonCloseFormMain = GUICtrlCreateButton("schlieen", 8, 552, 609, 33)

$Tab1 = GUICtrlCreateTab(8, 8, 609, 537)
GUICtrlSetFont(-1, 10, 400, 0, "Arial")

$TabSheet1 = GUICtrlCreateTabItem("Installation")
$Group1 = GUICtrlCreateGroup("Verfgbare Pakete", 16, 160, 265, 377)
$ListPacketsAvailable = GUICtrlCreateList("", 24, 184, 249, 344)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group2 = GUICtrlCreateGroup("Ausgewhlte Pakete", 344, 160, 265, 377)
$ButtonInstallationStart = GUICtrlCreateButton("starte jetzt", 352, 488, 121, 41) ;, $BS_ICON)
GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "starte Auswahl")
;GUICtrlSetImage(-1, "shell32.dll", -163)
$ButtonInstallationCreateJob = GUICtrlCreateButton("erstelle Jobs", 483, 487, 121, 41) ;, $BS_ICON)
GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
GUICtrlSetTip(-1, "Erstelle Jobs mit Auswahl")
;GUICtrlSetImage(-1, "shell32.dll", -21)
$ListPacketsSelected = GUICtrlCreateList("", 352, 184, 249, 305)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group3 = GUICtrlCreateGroup("Paketgruppe", 344, 48, 265, 105)
$ComboPacketgroup = GUICtrlCreateCombo("ComboPacketgroup", 352, 72, 249, 25, BitOR($CBS_DROPDOWNLIST,$WS_VSCROLL,$CBS_SORT))
$ButtonPacketgroupNew = GUICtrlCreateButton("Neu", 352, 104, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "Neu")
GUICtrlSetImage(-1, "shell32.dll", -44)
$ButtonPacketgroupSave = GUICtrlCreateButton("speichern", 524, 104, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "speichern")
GUICtrlSetImage(-1, "shell32.dll", -7)
$ButtonPacketgroupDelete = GUICtrlCreateButton("lschen", 438, 104, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "lschen")
GUICtrlSetImage(-1, "shell32.dll", -132)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$ButtonPacketsSelectAll = GUICtrlCreateButton("Alle >>", 288, 200, 49, 41)
$ButtonPacketsSelect = GUICtrlCreateButton(">>", 288, 240, 49, 41)
$ButtonPacketsDeSelectAll = GUICtrlCreateButton("<< Alle", 288, 368, 49, 41)
$ButtonPacketsDeSelect = GUICtrlCreateButton("<<", 288, 328, 49, 41)
$Label2 = GUICtrlCreateLabel("AppDirector " & $VERSION, 32, 56, 241, 41)
GUICtrlSetFont(-1, 24, 800, 0, "MS Sans Serif")
GUICtrlSetColor(-1, 0xA6CAF0)
$Label1 = GUICtrlCreateLabel($COPYRIGHT, 32, 99, 241, 17)
GUICtrlSetColor(-1, 0x808080)

;GUICtrlCreateGroup("", -99, -99, 1, 1)

$TabSheet3 = GUICtrlCreateTabItem("Pakete")
$Group8 = GUICtrlCreateGroup("Hinweis", 16, 48, 593, 121)
$txtLabelPacketInfo = "Hier werden die Skriptpakete erstellt, bzw. bearbeitet. In jeder Zeile muss eine abgeschlossene " & _
"Befehlskette stehen. Das an beliebiger Stelle einfgbare Schlsselwort %repository% wird beim Abarbeiten durch den  " & _
"konfigurierten Installationspfad ersetzt. Siehe Kartenreiter <Einstellungen>." & _
"Als Bedinung zur Ausfhrung kann Ordner, Datei, REG-Name oder REG-Value geprft werden." & @CRLF & _
"Bsp.: HKLM\SOFTWARE\Microsoft\WAB\Export\CSV:Entry=CSVExport"

$LabelPacketInfo = GUICtrlCreateLabel($txtLabelPacketInfo, 24, 65, 550, 120)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group9 = GUICtrlCreateGroup("Paket", 16, 176, 593, 361)
$ComboPacket = GUICtrlCreateCombo("", 24, 200, 313, 25)
;, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL,$CBS_SORT))
$ButtonPacketNew = GUICtrlCreateButton("Neu", 344, 200, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "Neu")
GUICtrlSetImage(-1, "shell32.dll", -44)
$ButtonPacketDelete = GUICtrlCreateButton("lschen", 430, 200, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "lschen")
GUICtrlSetImage(-1, "shell32.dll", -132)
$ButtonPacketSave = GUICtrlCreateButton("speichern", 516, 200, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "speichern")
GUICtrlSetImage(-1, "shell32.dll", -7)

$GroupCondition = GUICtrlCreateGroup("Bedingung (optional)", 24, 240, 577, 73)
$LabelCondition = GUICtrlCreateLabel("Paket ausfhren, wenn Datei, Ordner, REG-Key:", 32, 256, 300, 17)
$InputConditionValue = GUICtrlCreateInput("", 32, 280, 521, 21)
$RadioConditionExistent = GUICtrlCreateRadio("vorhanden", 328, 256, 89, 17)
GUICtrlSetState(-1, $GUI_CHECKED)
$RadioConditionNotExistent = GUICtrlCreateRadio("NICHT vorhanden", 456, 256, 137, 17)
;GUICtrlCreateGroup("", -99, -99, 1, 1)

$EditPacket = GUICtrlCreateEdit("", 24, 320, 577, 209)
GUICtrlSetFont(-1, 10, 400, 0, "Courier New")
$ButtonCheckCondition = GUICtrlCreateButton("teste", 560, 280, 33, 25, $BS_ICON)
GUICtrlSetImage(-1, "C:\WINDOWS\system32\shell32.dll", -23, 0)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$TabSheet2 = GUICtrlCreateTabItem("Jobs")
$Group7 = GUICtrlCreateGroup("Offene Jobs", 16, 48, 593, 489)
$ListOpenJobs = GUICtrlCreateListView("Computer|Job erstellt|Installations-Paket(e)", 24, 120, 577, 396,$LVS_SORTASCENDING)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_LV_ALTERNATE)
$ButtonJobOpenJob = GUICtrlCreateButton("ffne Job", 24, 72, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "ffne Jobdatei")
GUICtrlSetImage(-1, "shell32.dll", -172)
$ButtonJobDelete = GUICtrlCreateButton("lschen", 112, 72, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "lschen")
GUICtrlSetImage(-1, "shell32.dll", -132)
$ButtonUpdateListOpenJobs = GUICtrlCreateButton("aktualisieren", 200, 72, 81, 41, $BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", -206)
GUICtrlSetTip(-1, "Liste aktualisieren")
;$ButtonPlatzhalter = GUICtrlCreateButton("Platzhalter", 288, 72, 81, 41, $BS_ICON)

$TabSheet4 = GUICtrlCreateTabItem("Logs")
$GroupLogs = GUICtrlCreateGroup("Logdateien", 16, 48, 593, 489)
$ListLogs = GUICtrlCreateListView("Computer|letzte nderung|Meldung", 24, 120, 577, 396,$LVS_SORTASCENDING)
GUICtrlSetBkColor(-1, $GUI_BKCOLOR_LV_ALTERNATE)
$ButtonLogOpenLog = GUICtrlCreateButton("ffne Log", 24, 72, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "ffne Logdatei")
GUICtrlSetImage(-1, "shell32.dll", -172)
$ButtonLogDelete = GUICtrlCreateButton("lschen", 112, 72, 81, 41, $BS_ICON)
GUICtrlSetTip(-1, "lschen")
GUICtrlSetImage(-1, "shell32.dll", -132)
$ButtonUpdateListLogs = GUICtrlCreateButton("aktualisieren", 200, 72, 81, 41, $BS_ICON)
GUICtrlSetImage(-1, "shell32.dll", -206)
GUICtrlSetTip(-1, "Liste aktualisieren")

$TabSheet5 = GUICtrlCreateTabItem("Einstellungen")
$Group10 = GUICtrlCreateGroup("Pfad zu den Installationsprogrammen (%repository%)", 16, 48, 593, 57)
$InputRepositoryPath = GUICtrlCreateInput("InputRepositoryPath", 24, 72, 545, 21,BitOR($ES_AUTOHSCROLL,$ES_READONLY))
$ButtonRepositoryPath = GUICtrlCreateButton("...", 576, 70, 27, 25)

GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

Initialize()
LoadFormData()

;---------------------------------------------
; Events
;---------------------------------------------
While 1
	$nMsg = GUIGetMsg(1)
	Switch $nMsg[0]
		Case $ComboPacketGroup
			LoadPacketGroup()

		Case $ButtonPacketgroupNew
			NewPacketGroup()

		Case $ButtonPacketgroupSave
			SavePacketGroup()

		Case $ButtonPacketgroupDelete
			DeletePacketGroup()

		Case $ButtonPacketsSelect
			SelectPacket()

		Case $ButtonPacketsSelectAll
			SelectPacketAll()

		Case $ButtonPacketsDeSelect
			DeSelectPacket()

		Case $ButtonPacketsDeSelectAll
			DeSelectPacketAll()

		Case $ButtonInstallationStart
			StartAppProvider()

		Case $ButtonInstallationCreateJob
			ShowFormComputer()


		Case $ButtonJobOpenJob
			OpenJobFile()

		Case $ButtonJobDelete
			DeleteJob()

		Case $ButtonUpdateListOpenJobs
			LoadTabSheetJobstatus()

		Case $ListOpenJobs
			_GUICtrlListView_SortItems($ListOpenJobs, GUICtrlGetState($ListOpenJobs))


		Case $ButtonLogOpenLog
			OpenLogFile()

		Case $ButtonLogDelete
			DeleteLog()

		Case $ButtonUpdateListLogs
			LoadTabSheetLogs()

		Case $ListLogs
			_GUICtrlListView_SortItems($ListLogs, GUICtrlGetState($ListLogs))


		Case $ComboPacket
			LoadPacket()

		Case $ButtonPacketNew
			NewPacket()

		Case $ButtonPacketSave
			SavePacket()

		Case $ButtonPacketDelete
			DeletePacket()

		Case $ButtonCheckCondition
			CheckConditionEntry()

		Case $ComboComputerGroup
			LoadComputerGroup()

		Case $ButtonComputergroupNew
			NewComputerGroup()

		Case $ButtonComputergroupSave
			SaveComputerGroup()

		Case $ButtonComputergroupDelete
			DeleteComputerGroup()

		Case $ButtonComputerSelect
			SelectComputer()

		Case $ButtonComputerSelectAll
			SelectComputerAll()

		Case $ButtonComputerDeSelect
			DeSelectComputer()

		Case $ButtonComputerDeSelectAll
			DeSelectComputerAll()

		Case $ButtonComputerNew
			NewComputer()

		Case $ButtonComputerDelete
			DeleteComputer()

		Case $ButtonComputerNetworkScan
			ScanComputerNetwork()

		Case $ButtonComputerCreateJobs
			CreateComputerJobs()

		Case $ButtonComputerAbbrechen
			GUISwitch($FormComputer)
			GUIDelete()

		Case $ButtonCloseFormMain
			GUISwitch($FormMain)
			GUIDelete()
			Exit

		Case $ButtonRepositoryPath
			SelectRepositoryPath()


		Case $GUI_EVENT_CLOSE
			If $nMsg[1] = $FormComputer Then
				;Switch to the child window
				GUISwitch($FormComputer)
				;Destroy the child GUI including the controls
				GUIDelete()

			ElseIf $nMsg[1] = $FormMain Then
				;Switch to the parent window
				GUISwitch($FormMain)
				;Destroy the parent GUI including the controls
				GUIDelete()
				;Exit the script
				Exit
			EndIf

	EndSwitch
WEnd

;---------------------------------------------
; Functions
;---------------------------------------------
Func Initialize()
	;Prfe, ob INIFILE (Konfigurationsdatei)vorhanden ist - falls nicht --> erstellen
	If not FileExists($INIFILE) Then
		MsgBox(48, "ACHTUNG", "Konfigurationsdatei (" & $INIFILE & ") konnte nicht gefunden werden!" & @LF & @LF & "Erzeuge neue Datei...")

		;Erstelle DEFAULT-Schlssel
		IniWrite($INIFILE,"Paths","repository",@ScriptDir & "\repository")

		IniWrite($INIFILE,"PacketGroups","Beispielprofil1","1")
		IniWrite($INIFILE,"PacketGroup_Beispielprofil1","Beispielskript1","1")
		IniWrite($INIFILE,"Packets_Selected","Beispielskript1","1")
    EndIf

	;Lege Spaltenbreiten in Listviews fest
	_GUICtrlListView_SetColumnWidth($ListOpenJobs,0,120)
	_GUICtrlListView_SetColumnWidth($ListOpenJobs,1,130)
	_GUICtrlListView_SetColumnWidth($ListOpenJobs,2,330)


	_GUICtrlListView_SetColumnWidth($ListLogs,0,120)
	_GUICtrlListView_SetColumnWidth($ListLogs,1,130)
	_GUICtrlListView_SetColumnWidth($ListLogs,2,330)

	;Damit Listview-Spalten-Sortierfunktion geht:
	_GUICtrlListView_RegisterSortCallBack($ListOpenJobs)
	_GUICtrlListView_RegisterSortCallBack($ListLogs)

EndFunc

Func LoadFormData()

	LoadTabSheetInstallation()
	LoadTabSheetJobstatus()
	LoadTabSheetPackets()
	;loadTabSheetComputer() ; wird jetzt in func LoadFormComputer() aufgerufen
	LoadTabSheetLogs()
	LoadTabSheetEinstellungen()

EndFunc

Func ShowFormComputer()
	#Region ### START Koda GUI section ### Form=
	$FormComputer = GUICreate("Computer", 624, 553, 194, 125,-1,-1,$FormMain)
	GUISetFont(10, 400, 0, "MS Sans Serif")
	$Group4 = GUICtrlCreateGroup("Computergruppe", 340, 5, 265, 105)
	$ComboComputerGroup = GUICtrlCreateCombo("", 348, 29, 249, 25, BitOR($GUI_SS_DEFAULT_COMBO,$CBS_SIMPLE,$CBS_SORT))
	$ButtonComputerGroupNew = GUICtrlCreateButton("Neu", 348, 61, 81, 41, $BS_ICON)
	GUICtrlSetTip(-1, "Neu")
	GUICtrlSetImage(-1, "shell32.dll", -44)
	$ButtonComputerGroupSave = GUICtrlCreateButton("speichern", 520, 61, 81, 41, $BS_ICON)
	GUICtrlSetTip(-1, "speichern")
	GUICtrlSetImage(-1, "shell32.dll", -7)
	$ButtonComputerGroupDelete = GUICtrlCreateButton("lschen", 434, 61, 81, 41, $BS_ICON)
	GUICtrlSetTip(-1, "lschen")
	GUICtrlSetImage(-1, "shell32.dll", -132)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$Group5 = GUICtrlCreateGroup("Ausgewhlte Computer", 340, 117, 265, 377)
	$ListComputersSelected = GUICtrlCreateList("", 348, 141, 249, 315)
	GUICtrlSetData(-1, "")
	$ButtonComputerCreateJobs = GUICtrlCreateButton("erstelle Jobs", 352, 448, 241, 41)
	GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$Group6 = GUICtrlCreateGroup("Verfgbare Computer", 14, 5, 265, 489)
	$ListComputersAvailable = GUICtrlCreateList("", 22, 77, 249, 420)
	GUICtrlSetData(-1, "")
	$ButtonComputerNew = GUICtrlCreateButton("Neu", 22, 29, 81, 41, $BS_ICON)
	GUICtrlSetTip(-1, "Neu")
	GUICtrlSetImage(-1, "shell32.dll", -44)
	$ButtonComputerDelete = GUICtrlCreateButton("lschen", 106, 29, 81, 41, $BS_ICON)
	GUICtrlSetTip(-1, "lschen")
	GUICtrlSetImage(-1, "shell32.dll", -132)
	$ButtonComputerNetworkScan = GUICtrlCreateButton("Netzwerk scannen", 190, 29, 81, 41, $BS_ICON)
	GUICtrlSetTip(-1, "Netzwerk scannen")
	GUICtrlSetImage(-1, "shell32.dll", -19)
	GUICtrlCreateGroup("", -99, -99, 1, 1)
	$ButtonComputerSelectAll = GUICtrlCreateButton("Alle >>", 288, 160, 49, 41)
	$ButtonComputerSelect = GUICtrlCreateButton(">>", 288, 200, 49, 41)
	$ButtonComputerDeSelect = GUICtrlCreateButton("<<", 288, 288, 49, 41)
	$ButtonComputerDeSelectAll = GUICtrlCreateButton("<< Alle", 288, 328, 49, 41)
	$ButtonComputerAbbrechen = GUICtrlCreateButton("schlieen", 16, 504, 585, 33)
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###

	LoadTabSheetComputer()

EndFunc

Func LoadTabSheetInstallation()
	;Schreibe ComboPacketGroups
	$arrPacketGroups = IniReadSection($INIFILE, "PacketGroups")
	$strPacketGroups = ""
	if IsArray($arrPacketGroups) Then
		For $i = 1 To $arrPacketGroups[0][0]
			$strPacketGroups = $strPacketGroups & "|" & $arrPacketGroups[$i][0]
		Next
	EndIf
	GUICtrlSetData($ComboPacketGroup,$strPacketGroups,GUICtrlRead($ComboPacketGroup))

	;Schreibe ListPacketsAvailable
	$arrPacketsAvailable = _FileListToArray($PATH_PACKETS,"*.ini",1)
	If IsArray ($arrPacketsAvailable) Then
		GUICtrlSetData($ListPacketsAvailable,"") ;Liste leeren
		For $i = 1 To $arrPacketsAvailable[0]
			$arrPacketsAvailable[$i] = StringReplace($arrPacketsAvailable[$i],".ini","")

			;Entferne bereits Selectierte Pakete
			$var = IniRead($INIFILE, "Packets_Selected",$arrPacketsAvailable[$i], "NotFound")
			If $var = "NotFound" Then
				GUICtrlSetData($ListPacketsAvailable,$arrPacketsAvailable[$i] & "|")
			EndIf
		Next
	EndIf

	;Schreibe ListPacketsSelected
	GUICtrlSetData($ListPacketsSelected,"") ;Liste leeren
	$arrPacketsSelected = IniReadSection($INIFILE, "Packets_Selected")
	If Not @error Then
		For $i = 1 To $arrPacketsSelected[0][0]

			;Wenn Selektiertes Paket in arrPacketsAvailable...
			If _ArraySearch($arrPacketsAvailable,$arrPacketsSelected[$i][0]) Then
				;Schreibe in Installationsliste
				GUICtrlSetData($ListPacketsSelected,StringRight("0" & $i,2) & " " & $arrPacketsSelected[$i][0] & "|")
			Else
				;Entferne Dateileichen aus Installationsliste
				IniDelete( $INIFILE, "Packets_Selected",$arrPacketsSelected[$i][0] )
			EndIf
		Next
	EndIf
EndFunc

Func LoadPacketGroup()
	Local $arrData, $pg
	$pg=GUICtrlRead($ComboPacketGroup)
	$arrData = IniReadSection($INIFILE, "PacketGroup_" & $pg)
	IniWriteSection($INIFILE, "Packets_Selected",$arrData)
	LoadTabSheetInstallation()
EndFunc

Func NewPacketGroup()
	Local $pg
	$pg = InputBox("NEUE PaketGruppe","Bitte aussagekrftigen Namen angeben!" & @CRLF _
	& "z.B.: Standard Office-PC")

	If $pg <> "" then
		IniWrite($INIFILE, "PacketGroups",$pg,"1")
		IniDelete( $INIFILE, "Packets_Selected")
		LoadTabSheetInstallation()

		;Selektiere neue Paketgruppe in Combobox
		ControlCommand ( "", "", $ComboPacketGroup,"SelectString", $pg)
   EndIf
EndFunc

Func SavePacketGroup()
	Local $arrData, $pg
	$pg=GUICtrlRead($ComboPacketGroup)
	IniWrite($INIFILE, "PacketGroups",$pg,"1")
	$arrData = IniReadSection($INIFILE, "Packets_Selected")
	IniWriteSection($INIFILE, "PacketGroup_" & $pg,$arrData)
	LoadTabSheetInstallation()
EndFunc

Func DeletePacketGroup()
	Local $pg
	$pg=GUICtrlRead($ComboPacketGroup)
	IniDelete( $INIFILE, "PacketGroups",$pg )
	IniDelete( $INIFILE, "PacketGroup_" & $pg)
	IniWriteSection($INIFILE, "Packets_Selected","")
	LoadTabSheetInstallation()
 EndFunc

Func SelectPacket()
	Local $item = GUICtrlRead($ListPacketsAvailable)
	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		IniWrite($INIFILE, "Packets_Selected", $item, "1")
		LoadTabSheetInstallation()
	EndIf
EndFunc

Func SelectPacketAll()
	IniDelete( $INIFILE, "Packets_Selected")
	For $i = 1 To $arrPacketsAvailable[0]
		IniWrite($INIFILE, "Packets_Selected", $arrPacketsAvailable[$i], "1")
	Next
	LoadTabSheetInstallation()
EndFunc

Func DeSelectPacket()
	Local $item = GUICtrlRead($ListPacketsSelected)
	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		$item = StringRight($item, StringLen($item)-3)
		IniDelete($INIFILE, "Packets_Selected", $item)
		LoadTabSheetInstallation()
	EndIf
EndFunc

Func DeSelectPacketAll()
	IniDelete( $INIFILE, "Packets_Selected")
	LoadTabSheetInstallation()
EndFunc

Func StartAppProvider()
	Local $arrPackets, $i
	$arrPackets = IniReadSection($INIFILE,"Packets_Selected")
	If IsArray($arrPackets) Then
		; Lsche eventuell vorhandene Jobdatei
		FileDelete($PATH_JOBS & "\" & @ComputerName & ".ini")
		For $i=1 To $arrPackets[0][0]
			IniWrite($PATH_JOBS & "\" & @ComputerName & ".ini","Packets",$arrPackets[$i][0],"open")
		Next
	EndIf

	If FileExists(@ScriptDir & "\AppProvider.exe") Then
		Run(@ScriptDir & "\AppProvider.exe")
	ElseIf FileExists(@ScriptDir & "\AppProvider.au3") Then
		RunAU3("AppProvider.au3")
	Else
		MsgBox(16,"Abbruch", "Kann folgendes Programm nicht finden:" &  @LF & @ScriptDir & "\AppProvider.exe")
	EndIf
EndFunc

Func RunAU3($sFilePath, $sWorkingDir = "", $iShowFlag = @SW_SHOW, $iOptFlag = 0)
    Return Run('"' & @AutoItExe & '" /AutoIt3ExecuteScript "' & $sFilePath & '"', $sWorkingDir, $iShowFlag, $iOptFlag)
EndFunc   ;==>_RunAU3



Func LoadTabSheetJobstatus()
	Local $arrPacks, $strPacks, $arrJobs, $PRE="(",$POST=")", $strFileCreated="", $arrFileCreated, $i,$x
	$arrJobs = _FileListToArray($PATH_JOBS,"*.ini",1)
	_GUICtrlListView_DeleteAllItems($ListOpenJobs) ;Liste leeren
	If IsArray($arrJobs) Then
		_GUICtrlListView_BeginUpdate($ListOpenJobs) ;Wegen Geschwindigkeit Listview kurz modifiziert...
		For $i = 1 To $arrJobs[0]
			$arrFileCreated = FileGetTime($PATH_JOBS & "\" & $arrJobs[$i],1,0)
			$strFileCreated = $arrFileCreated[0] & "-" & $arrFileCreated[1] & "-" & $arrFileCreated[2] & " " & _
			$arrFileCreated[3] & ":" & $arrFileCreated[4] & ":" & $arrFileCreated[5]

			$arrPacks = IniReadSection($PATH_JOBS & "\" & $arrJobs[$i],"Packets")

			$strPacks=""
			If IsArray($arrPacks) Then
				For $x=1 To $arrPacks[0][0]
					$strPacks = $strPacks & $PRE &$arrPacks[$x][0] & $POST
				Next
			EndIf

			$arrJobs[$i] = StringReplace($arrJobs[$i],".ini","")
			GUICtrlCreateListViewItem($arrJobs[$i] & "|" & $strFileCreated & "|" & $strPacks & "|", $ListOpenJobs)
			GUICtrlSetBkColor(-1,$LV_ALTERNATE_COLOR)
		Next
		_GUICtrlListView_EndUpdate($ListOpenJobs)
	EndIf
EndFunc

Func LoadTabSheetLogs()
	Local $LastStatus, $arrLogs, $PRE="(",$POST=")", $strFileUpdated="", $arrFileUpdated
	$arrLogs = _FileListToArray($PATH_LOGS,"*.txt",1)
	_GUICtrlListView_DeleteAllItems($ListLogs) ;Liste leeren
	If IsArray($arrLogs) Then
		_GUICtrlListView_BeginUpdate($ListLogs) ;Wegen Geschwindigkeit Listview kurz modifiziert...
		For $i = 1 To $arrLogs[0]
			$arrFileUpdated = FileGetTime($PATH_LOGS & "\" & $arrLogs[$i],0,0)
			$strFileUpdated = $arrFileUpdated[0] & "-" & $arrFileUpdated[1] & "-" & $arrFileUpdated[2] & " " & _
			$arrFileUpdated[3] & ":" & $arrFileUpdated[4] & ":" & $arrFileUpdated[5]

			$LastStatus = IniRead($PATH_LOGS & "\" & $arrLogs[$i],"LastStatus","status","")
			$LastStatusFailureTxt = IniRead($PATH_LOGS & "\" & $arrLogs[$i],"LastStatus","FailureTxt","")

			$arrLogs[$i] = StringReplace($arrLogs[$i],".txt","")
			GUICtrlCreateListViewItem($arrLogs[$i] & "|" & $strFileUpdated & "|" & $LastStatus & " " & $LastStatusFailureTxt & "|", $ListLogs)
			GUICtrlSetBkColor(-1,$LV_ALTERNATE_COLOR)
		Next
		_GUICtrlListView_EndUpdate($ListLogs)
	EndIf
EndFunc



Func OpenJobFile()
	Local $item = GUICtrlRead(GUICtrlRead($ListOpenJobs))

	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		Local $arrComputer = StringSplit($item,"|")

		If FileExists($PATH_JOBS & "\" & $arrComputer[1] & ".ini") Then
			;Run("Notepad.exe " & $PATH_JOBS & "\" & $arrComputer[1] & ".ini")
			Run(@comspec & ' /c start ' & $PATH_JOBS & "\" & $arrComputer[1] & ".ini", '', @SW_HIDE)
		EndIf
		LoadTabSheetJobstatus()
	EndIf
EndFunc

Func DeleteJob()
	Local $item = GUICtrlRead(GUICtrlRead($ListOpenJobs))

	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		Local $arrComputer = StringSplit($item,"|")
		If MsgBox(4+48+256,"Lschen", "Wirklich lschen: " & $arrComputer[1] ) = 6 Then
			FileDelete($PATH_JOBS & "\" & $arrComputer[1] & ".ini")
			LoadTabSheetJobstatus()
		EndIf
	EndIf
EndFunc

Func OpenLogFile()
	Local $item = GUICtrlRead(GUICtrlRead($ListLogs))

	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		Local $arrComputer = StringSplit($item,"|")
		;Local $hFileOpen = FileOpen($PATH_LOGS & "\" & $arrComputer[1] & ".txt", $FO_READ)
		;MsgBox(64,"Logdatei: " & $arrComputer[1] & ".txt" ,FileRead($hFileOpen))
		;FileClose($hFileOpen)
		If FileExists($PATH_LOGS & "\" & $arrComputer[1] & ".txt") Then
			;Run("Notepad.exe " & $PATH_LOGS & "\" & $arrComputer[1] & ".txt")
			Run(@comspec & ' /c start ' & $PATH_LOGS & "\" & $arrComputer[1] & ".txt", '', @SW_HIDE)
		EndIf
		LoadTabSheetLogs()
	EndIf
EndFunc

Func DeleteLog()
	Local $item = GUICtrlRead(GUICtrlRead($ListLogs))

	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		Local $arrComputer = StringSplit($item,"|")
		If MsgBox(4+48+256,"Lschen", "Wirklich lschen: " & $arrComputer[1] ) = 6 Then
			FileDelete($PATH_LOGS & "\" & $arrComputer[1] & ".txt")
			LoadTabSheetLogs()
		EndIf
	EndIf
EndFunc

Func LoadTabSheetPackets()
	;Schreibe ComboPacket
	$arrPacketsAvailable = _FileListToArray($PATH_PACKETS,"*.ini",1)

	If IsArray ($arrPacketsAvailable) Then
		GUICtrlSetData($ComboPacket,"") ;Liste leeren
		For $i = 1 To $arrPacketsAvailable[0]
			$arrPacketsAvailable[$i] = StringReplace($arrPacketsAvailable[$i],".ini","")
			GUICtrlSetData($ComboPacket,$arrPacketsAvailable[$i] & "|")
		Next
	EndIf
EndFunc

Func CheckConditionEntry()
	;Prft, ob Bedingungseintrag (Datei, Ordner, RegKey, RegKeyValue) wahr ist.
	Local $condition, $IsRegKey=False, $arr, $msg, $regkey, $regname, $regvalue

	$condition = GUICtrlRead($InputConditionValue)
	If StringLen($condition) = 0 Then Return

	; Prfe, ob es ein Registryeintrag ist.
	; Startet mit "HKEY_LOCAL_MACHINE" ("HKLM") or "HKEY_USERS" ("HKU") or "HKEY_CURRENT_USER" ("HKCU") or "HKEY_CLASSES_ROOT" ("HKCR") or "HKEY_CURRENT_CONFIG" ("HKCC").

	$arr = StringSplit($condition,"\")
	If IsArray($arr) Then
		Switch $arr[1]
			Case "HKEY_LOCAL_MACHINE"
				$IsRegKey=True
			Case "HKLM"
				$IsRegKey=True
			Case "HKEY_USERS"
				$IsRegKey=True
			Case "HKU"
				$IsRegKey=True
			Case "HKEY_CURRENT_USER"
				$IsRegKey=True
			Case "HKCU"
				$IsRegKey=True
			Case "HKEY_CLASSES_ROOT"
				$IsRegKey=True
			Case "HKCR"
				$IsRegKey=True
			Case "HKEY_CURRENT_CONFIG"
				$IsRegKey=True
			Case "HKCC"
				$IsRegKey=True
			Case Else
				$IsRegKey=False
		EndSwitch
	EndIf

	;Text fr Messagebox
	$msg = $condition

	If $IsRegKey Then
		;Prfe ob Regkey vorhanden, oder Regvalue einen Wert hat

		;Wenn ":" vorhanden, ist REG-Name angegeben
		$arr = StringSplit($condition,":")
		If IsArray($arr) And $arr[0] = 2 Then
			$regkey = $arr[1]
			$regname= $arr[2]

			;Wenn "=" vorhanden, ist REG-Wert angegeben
			$arr = StringSplit($regname,"=")
			If IsArray($arr) And $arr[0] = 2 Then
				$regname = $arr[1]
				$regvalue = $arr[2]
			Else
				$regvalue = ""
			EndIf

			;Lese Registry
			Local $erg = RegRead($regkey,$regname)
			If $erg Then
				If $erg = $regvalue Then
					$msg = $msg & @CRLF & @CRLF & "gefunden!"& @CRLF & @CRLF & "Wert ist identisch: " & $erg
				ElseIf $regvalue == "" Then
					$msg = $msg & @CRLF & @CRLF & "gefunden!"
				Else
					$msg = $msg & @CRLF & @CRLF & "Wert nicht identisch: " & @CRLF & _
					"  Suchwert: " & $regvalue &  @CRLF & "  Suchergebnis: " & $erg
				EndIf
			Else
				$msg = $msg & @CRLF & @CRLF & "NICHT gefunden!"
			EndIf

		Else
			$msg = "Registry-Name fehlt!"& @CRLF & @CRLF & $msg & ":[REG-Name]"
		EndIf

	Else
		;Prfe, ob Datei oder Ordner vorhanden
		If FileExists($condition) Then
			$msg = $msg & @CRLF & @CRLF & "gefunden!"
		Else
			$msg = $msg & @CRLF & @CRLF & "NICHT gefunden!"
		EndIf
	EndIf

	MsgBox(64, "Bedingung -CHECK", $msg)

EndFunc

Func LoadPacket()
	Local $arrScript, $strScript = "", $packet, $conditionValue, $conditionExistent
	$packet = GUICtrlRead($ComboPacket)

	;Hole Befehle aus INI
	$arrScript = IniReadSection($PATH_PACKETS & "\" & $packet & ".ini","commands")
	;_ArrayDisplay($arrScript,"$arrScript")
	If IsArray($arrScript) Then
		For $i = 1 To $arrScript[0][0]
			$strScript = $strScript & $arrScript[$i][1] & @CRLF
		Next
		GUICtrlSetData($EditPacket, $strScript)
	Else
		GUICtrlSetData($EditPacket, "");Editierfeld leeren
	EndIf

	;Hole Bedingungswert aus INI
	$conditionValue = IniRead($PATH_PACKETS & "\" & $packet & ".ini","condition", "value","")
	GUICtrlSetData($InputConditionValue, $conditionValue)

	;Hole BedingungsExistenzflag aus INI
	$conditionExistent  = IniRead($PATH_PACKETS & "\" & $packet & ".ini","condition", "existent","TRUE")
	If $conditionExistent == "TRUE" Then
		GUICtrlSetState($RadioConditionExistent, $GUI_CHECKED)
	Else
		GUICtrlSetState($RadioConditionNotExistent, $GUI_CHECKED)
	EndIf

	;LoadTabSheetPackets()
EndFunc

Func NewPacket()
	Local $packet
	$packet = InputBox("NEUES Paket","Bitte aussagekrftigen Namen angeben!" & @CRLF _
	& "z.B.: Ultimatives Programm 10.04")

	If $packet <> "" then
		IniWrite($PATH_PACKETS & "\" & $packet & ".ini","commands","1","")

		LoadTabSheetPackets()

		;Selektiere neues Paket in Combobox
		ControlCommand ( "", "", $ComboPacket,"SelectString", $packet)
   EndIf

EndFunc

Func SavePacket()
	Local $packet, $arrScript
	$packet=GUICtrlRead($ComboPacket)

	If $packet <> "" then
		;Entferne Zeilenumbrche aus Script
		Local $strEditPacket = GUICtrlRead($EditPacket)
		$strEditPacket = StringReplace($strEditPacket,@CRLF,"~")

		;Erzeuge Array aus Scriptzeilen
		$arrScript = StringSplit($strEditPacket,"~")

		;Schreibe Array-Commands in Paketdatei
		If IsArray($arrScript) Then
			IniDelete($PATH_PACKETS & "\" & $packet & ".ini","commands") ;Liste leeren
			For $i=1 to $arrScript[0]
				If StringLen(StringReplace($arrScript[$i]," ",""))>0 Then
					IniWrite($PATH_PACKETS & "\" & $packet & ".ini","commands",$i,$arrScript[$i])
				EndIf
			Next
		EndIf

		;Schreibe Bedingungswert in Paketdatei
		IniWrite($PATH_PACKETS & "\" & $packet & ".ini","condition", "value",GUICtrlRead($InputConditionValue))

		;Schreibe BedingungsExistenzflag in Paketdatei
		If GUICtrlRead($RadioConditionExistent) = $GUI_CHECKED Then
			IniWrite($PATH_PACKETS & "\" & $packet & ".ini","condition", "existent","TRUE")
		Else
			IniWrite($PATH_PACKETS & "\" & $packet & ".ini","condition", "existent","FALSE")
		EndIf

		LoadTabSheetInstallation()
	EndIf
EndFunc

Func DeletePacket()
	Local $packet
	$packet=GUICtrlRead($ComboPacket)
	If MsgBox(4+48+256,"Lschen", "Wirklich lschen: " & $packet ) = 6 Then
		FileDelete($PATH_PACKETS & "\" & $packet & ".ini")
		GUICtrlSetData($EditPacket, "")
		LoadTabSheetPackets()
		LoadTabSheetInstallation()
	EndIf
EndFunc





Func LoadTabSheetComputer()
	;Schreibe ComboComputerGroups
	$arrComputerGroups = IniReadSection($INIFILE, "ComputerGroups")
	$strComputerGroups = ""
	For $i = 1 To $arrComputerGroups[0][0]
		$strComputerGroups = $strComputerGroups & "|" & $arrComputerGroups[$i][0]
	Next
	GUICtrlSetData($ComboComputerGroup,$strComputerGroups,GUICtrlRead($ComboComputerGroup))

	;Schreibe ListComputersAvailable
	$arrComputersAvailable = IniReadSection($INIFILE, "Computers_Available")
	If IsArray ($arrComputersAvailable) Then
		GUICtrlSetData($ListComputersAvailable,"") ;Liste leeren
		For $i = 1 To $arrComputersAvailable[0][0]

			;Entferne bereits Selectierte Computer
			$var = IniRead($INIFILE, "Computers_Selected",$arrComputersAvailable[$i][0], "NotFound")
			If $var = "NotFound" Then
				GUICtrlSetData($ListComputersAvailable,$arrComputersAvailable[$i][0] & "|")
			EndIf
		Next
	EndIf

	;Schreibe ListComputersSelected
	GUICtrlSetData($ListComputersSelected,"") ;Liste leeren
	$arrComputersSelected = IniReadSection($INIFILE, "Computers_Selected")
	If Not @error Then
		For $i = 1 To $arrComputersSelected[0][0]

			;Wenn Selektierter Computer in arrComputersAvailable...
			If _ArraySearch($arrComputersAvailable,$arrComputersSelected[$i][0]) Then
				;Schreibe in Liste der gewhlten Computer
				;GUICtrlSetData($ListComputersSelected,StringRight("0" & $i,2) & " " & $arrComputersSelected[$i][0] & "|")
				GUICtrlSetData($ListComputersSelected,$arrComputersSelected[$i][0] & "|")
			Else
				;Entferne Dateileichen aus Computerliste
				IniDelete( $INIFILE, "Computers_Selected",$arrComputersSelected[$i][0] )
			EndIf
		Next
	EndIf

EndFunc

Func LoadComputerGroup()
	Local $arrData, $pg
	$pg=GUICtrlRead($ComboComputerGroup)
	$arrData = IniReadSection($INIFILE, "ComputerGroup_" & $pg)
	IniWriteSection($INIFILE, "Computers_Selected",$arrData)
	LoadTabSheetComputer()
EndFunc

Func NewComputerGroup()
	Local $pg
	$pg = InputBox("NEUE ComputerGruppe","Bitte aussagekrftigen Namen angeben!" & @CRLF _
	& "z.B.: Abteilung EDV")

	If $pg <> "" then
		IniWrite($INIFILE, "ComputerGroups",$pg,"1")
		IniDelete( $INIFILE, "Computers_Selected")
		LoadTabSheetComputer()

		;Selektiere neue Computergruppe in Combobox
		ControlCommand ( "", "", $ComboComputerGroup,"SelectString", $pg)
   EndIf
EndFunc

Func SaveComputerGroup()
	Local $arrData, $pg
	$pg=GUICtrlRead($ComboComputerGroup)
	IniWrite($INIFILE, "ComputerGroups",$pg,"1")
	$arrData = IniReadSection($INIFILE, "Computers_Selected")
	IniWriteSection($INIFILE, "ComputerGroup_" & $pg,$arrData)
	LoadTabSheetComputer()
EndFunc

Func DeleteComputerGroup()
	Local $pg
	$pg=GUICtrlRead($ComboComputerGroup)
	IniDelete( $INIFILE, "ComputerGroups",$pg )
	IniDelete( $INIFILE, "ComputerGroup_" & $pg)
	IniWriteSection($INIFILE, "Computers_Selected","")
	LoadTabSheetComputer()
 EndFunc

Func SelectComputer()
	Local $item = GUICtrlRead($ListComputersAvailable)
	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		IniWrite($INIFILE, "Computers_Selected", $item, "1")
		LoadTabSheetComputer()
	EndIf
EndFunc

Func SelectComputerAll()
	IniDelete( $INIFILE, "Computers_Selected")
	For $i = 1 To $arrComputersAvailable[0][0]
		IniWrite($INIFILE, "Computers_Selected", $arrComputersAvailable[$i][0], "1")
	Next
	LoadTabSheetComputer()
EndFunc

Func DeSelectComputer()
	Local $item = GUICtrlRead($ListComputersSelected)
	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	 Else
		IniDelete($INIFILE, "Computers_Selected", $item)
		LoadTabSheetComputer()
	EndIf
EndFunc

Func DeSelectComputerAll()
	IniDelete( $INIFILE, "Computers_Selected")
	LoadTabSheetComputer()
EndFunc

Func NewComputer()
	Local $computer
	$computer = InputBox("NEUER Computer","Bitte Namen angeben!")

	If $computer <> "" then
		IniWrite($INIFILE, "Computers_Available",$computer,"1")
		LoadTabSheetComputer()
   EndIf
EndFunc

Func DeleteComputer()
	Local $item = GUICtrlRead($ListComputersAvailable)
	If $item = "" Then
		MsgBox(64,"STOP","Bitte zuerst Datensatz markieren!",3)
	Else
		If MsgBox(4+48+256,"Lschen", "Wirklich lschen: " & $item ) = 6 Then
			;Lsche Computer- INIeintrag
			IniDelete($INIFILE, "Computers_Available", $item)
			LoadTabSheetComputer()
			;Lsche Jobfile
			FileDelete($PATH_JOBS & "\" & $item & ".ini")
			LoadTabSheetJobstatus()
		EndIf
	EndIf
EndFunc



Func ScanComputerNetwork()
	Local $ImportCount=0, $ImportList, $CheckComputer

	Local $rootDSE = ObjGet("LDAP://rootDSE")
	If @error Then
		MsgBox(16,"ABBRUCH","Kann keine Verbindung zum LDAP herstellen")
		Return 0
	EndIf

	Local $domain = @LogonDomain
	$domain = InputBox("DOMAIN-SCAN", "Zu durchsuchende Domain angeben!",$domain)
	If @error = 1 Then Return 0

	Local $objDomain = ObjGet("WinNT://" & $domain)
	If @error Then
	  MsgBox(16,"ABBRUCH","Kann keine Verbindung zur Domne <" & $domain & "> herstellen")
	  Return 0
	EndIf

	Local $arrSearch[1] = ["Computer"]
	$objDomain.Filter = $arrSearch
	Local $Computerlist
	For $objComputer In $objDomain
	 If $objComputer.Class = "Computer" Then
		$Computerlist = $Computerlist & $objComputer.Name & @CRLF
	 EndIf
	Next

	Local $aArray = StringSplit($Computerlist, @CRLF)

	If IsArray($aArray) Then
		For $i=1 To $aArray[0]

			;Computername importieren, falls noch nicht vorhanden
			$CheckComputer = IniRead($INIFILE, "Computers_Available",$aArray[$i],"NotFound")
			;ConsoleWrite($CheckComputer & @CRLF)

			If $CheckComputer == "NotFound" And StringLen($aArray[$i]) > 0 Then
				$ImportCount = $ImportCount + 1
				$ImportList = $ImportList & $aArray[$i] & @CRLF
				IniWrite($INIFILE, "Computers_Available",$aArray[$i],"1")
			EndIf
		Next

		If $ImportCount > 0 Then
			LoadTabSheetComputer()
			MsgBox(64, "DOMAIN-SCAN", "Es wurden " & $ImportCount & " neue Computer gefunden:" & @CRLF & @CRLF & $ImportList)
		Else
			MsgBox(64, "DOMAIN-SCAN", "Es wurden keine neuen Computer gefunden")
		EndIf
	EndIf

EndFunc


Func ScanComputerNetwork_ALT_per_Net_VIEW()
	Local $domain, $iPID, $iPosDataStart, $iPosDataEnd, $aArray, $sOutput, $i, $ImportCount = 0, $ImportList=""

	$domain = @LogonDomain
	$domain = InputBox("DOMAIN-SCAN", "Zu durchsuchende Domain angeben!",$domain)
	If @error = 1 Then Return 0

	; Fhre net view des Systems aus
	$iPID = Run(@ComSpec & ' /C NET VIEW /DOMAIN:"' & $domain , @SystemDir, @SW_HIDE, $STDOUT_CHILD)

	; Wait until the process has closed using the PID returned by Run.
	ProcessWaitClose($iPID)

	; Read the Stdout stream of the PID returned by Run. This can also be done in a while loop. Look at the example for StderrRead.
	$sOutput = StdoutRead($iPID)

	;Abbruch, falls keine Rckgabe
	If StringInStr($sOutput, "Es sind keine Eintr") Then
		MsgBox(16, "ABBRUCH", "Es wurden keine Eintrge gefunden")
		Return 0
	EndIf

	$iPosDataStart = StringInStr($sOutput, "\\")
	$iPosDataEnd = StringInStr($sOutput, "Der Befehl")

	; Extract relevant data from $sOutput
	$sOutput = StringMid($sOutput, $iPosDataStart, $iPosDataEnd - $iPosDataStart)

	; Use StringSplit to split the output of StdoutRead to an array. All carriage returns (@CRLF) are stripped and @CRLF (line feed) is used as the delimiter.
	$sOutput = StringTrimRight(StringStripCR($sOutput), StringLen(@CRLF))
	$aArray = StringSplit($sOutput, @CRLF)

	If IsArray($aArray) Then
		For $i=1 To $aArray[0]
			; Extract computername from String
			$aArray[$i] = StringReplace(StringLeft($aArray[$i],StringInStr($aArray[$i], " ")),"\\","")

			;Computername importieren, falls noch nicht vorhanden
			If IniRead($INIFILE, "Computers_Available",$aArray[$i],"NotFound") = "NotFound" Then
				$ImportCount = $ImportCount + 1
				$ImportList = $ImportList & $aArray[$i] & @CRLF
				IniWrite($INIFILE, "Computers_Available",$aArray[$i],"1")
			EndIf
		Next

		;_ArrayDisplay($aArray)

		If $ImportCount > 0 Then
			LoadTabSheetComputer()
			MsgBox(64, "DOMAIN-SCAN", "Es wurden " & $ImportCount & " neue Computer gefunden:" & @CRLF & @CRLF & $ImportList)
		Else
			MsgBox(64, "DOMAIN-SCAN", "Es wurden keine neuen Computer gefunden")
		EndIf

	EndIf


EndFunc

Func CreateComputerJobs()
	Local $arrPackets, $arrComputers, $strPakete
	$arrPackets = IniReadSection($INIFILE,"Packets_Selected")
	If @error then Return 0

	$arrComputers = IniReadSection($INIFILE,"Computers_Selected")
	If @error then Return 0

	For $i=1 to $arrComputers[0][0]
		; Lsche eventuell vorhandene Jobdatei
		FileDelete($PATH_JOBS & "\" & $arrComputers[$i][0] & ".ini")

		For $x=1 To $arrPackets[0][0]
			IniWrite($PATH_JOBS & "\" & $arrComputers[$i][0] & ".ini","Packets",$arrPackets[$x][0],"open")
			;Paketliste fr Msgbox weiter unten
			If $i=1 Then $strPakete = $strPakete & $arrPackets[$x][0] & @LF
		Next
		;IniWrite($PATH_JOBS & "\" & $arrComputers[$i][0] & ".ini","Status","Status","open")
	Next

	LoadTabSheetJobstatus()
	MsgBox(64, "Job-Erzeugung abgeschlossen", "Computer: " & $arrComputers[0][0] & @LF & @LF & "Pakete: " & @LF & $strPakete, 3)

EndFunc


Func LoadTabSheetEinstellungen()

	;Schreibe InputRepositoryPath
	GUICtrlSetData($InputRepositoryPath, IniRead($INIFILE, "Paths", "repository", ""))
EndFunc

Func SelectRepositoryPath()
	Local $folder = FileSelectFolder("Pfad zu den Installationsprogrammen whlen (Repository)", "")
	If $folder <> "" Then
		IniWrite($INIFILE, "Paths", "repository", $folder)
		LoadTabSheetEinstellungen()
	EndIf
EndFunc




Func WM_Notify_Events($hWndGUI, $MsgID, $wParam, $lParam)
	;Auswertung von Doppelklicks...
	#forceref $hWndGUI, $MsgID, $wParam
    Local $tagNMHDR, $event, $hwndFrom, $code
    $tagNMHDR = DllStructCreate("int;int;int", $lParam)
    If @error Then Return
    $event = DllStructGetData($tagNMHDR, 3)
    Select
		Case $wParam = $ListLogs
			Select
				Case $event = $NM_DBLCLK
					;ffne Logdatei
					OpenLogFile()
			EndSelect
		Case $wParam = $ListOpenJobs
			Select
				Case $event = $NM_DBLCLK
				;ffne Jobdatei
				OpenJobFile()
			EndSelect

    EndSelect
EndFunc



Func debug($msg, $error = @error, $extended = @extended, $erl = @ScriptLineNumber)
    ConsoleWrite("(" & $erl & ") : = (" & $error & ")(" & $extended & ") " & $msg & @LF)
    If $error <> 0 Then SetError($error, $extended, $error)
    Return $error
EndFunc   ;==>debug