#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=sources\AppProvider.ico
#AutoIt3Wrapper_UseUpx=n
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs
	Created By:
	Jochen Bierbauer (jbierbauer@gmx.de)

	Features:
	With this application you are able to

	2) Start script(s), that are created with AppDirector

	License:
	Copyright (C) 2014 Jochen Bierbauer

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
#ce

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <GUIListBox.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Array.au3>
#include <Timers.au3>
#include <Date.au3>
#include <Constants.au3>


Const $VERSION = "0.10.1"
Const $INIFILE = @ScriptDir & "\settings.ini"
Const $PATH_PACKETS = @ScriptDir & "\packets"
Const $PATH_JOBS = @ScriptDir & "\jobs"
Const $PATH_LOGS = @ScriptDir & "\logs"
Const $COPYRIGHT = " 2014 Jochen Bierbauer"
Const $STAT_OPEN    = "[       ] "
Const $STAT_FAILURE = "[error  ] "
Const $STAT_IGNORED = "[ignored]"
Const $STAT_OK      = "[O.K.   ] "
Const $STAT_ACTIVE  = "[ >>>>> ] "
Const $PROGRESS_WAIT = 150 ;Wartedauer fr Progressbar-Timer in Millisekunden

Global $ActivePacket
Global $PercentNow = 1 ;Progressbar aktueller Stand
Global $PercentMax = 2 ;Progressbar - bis zu diesem Stand aktuell vorwrtsgehen
Global $FormMain
Global $RepositoryPath


Initialize()
;---------------------------------------------
; Form
;---------------------------------------------
#Region ### START Koda GUI section ### Form=P:\Jochen\Projekte\Autoit\AppDirector\AppProvider.kxf
$FormMain = GUICreate("AppProvider " & $VERSION, 489, 423, 192, 124)
$GraphicHeaderBk = GUICtrlCreateGraphic(0, 0, 488, 81)
GUICtrlSetColor(-1, 0xD4D0C8)
GUICtrlSetBkColor(-1, 0xFFFFFF)
$PicLogo = GUICtrlCreatePic(@ScriptDir & "\"  & IniRead($INIFILE,"Branding","image_64x64","sources\AppProvider.jpg"),408, 8, 64, 64)

$Label1 = GUICtrlCreateLabel(IniRead($INIFILE,"Branding","Label1",""), 16, 14, 379, 20)
GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
GUICtrlSetBkColor(-1, 0xFFFFFF)
$Label2 = GUICtrlCreateLabel(IniRead($INIFILE,"Branding","Label2",""), 16, 31, 380, 20)
GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
GUICtrlSetBkColor(-1, 0xFFFFFF)
$Label3 = GUICtrlCreateLabel(IniRead($INIFILE,"Branding","Label3",""), 16, 48, 377, 20)
GUICtrlSetFont(-1, 10, 800, 0, "MS Sans Serif")
GUICtrlSetBkColor(-1, 0xFFFFFF)
$Label5 = GUICtrlCreateLabel("Folgende Pakete werden installiert:", 16, 86, 169, 17)

$ListPackets = GUICtrlCreateList("", 16, 104, 457, 253,BitOR($WS_BORDER, $WS_VSCROLL))
GUICtrlSetFont(-1, 10, 400, 0, "Courier New")
;GUICtrlSetData(-1, "[x] Sample|[ ] B.List|[ ] C.Control|[ ] D.Here", "[ ] B.List")
$Progressbar = GUICtrlCreateProgress(16, 360, 457, 25)
;GUICtrlSetData(-1, 60)
$Label4 = GUICtrlCreateLabel($COPYRIGHT, 16, 400, 457, 17)
GUICtrlSetColor(-1, 0x716F64)


GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###



;LoadFormData()
CallJobs()

;Switch to the parent window
GUISwitch($FormMain)

;Destroy the parent GUI including the controls
GUIDelete()

;Exit the script
Exit

;---------------------------------------------
; Events
;---------------------------------------------
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			_Timer_KillAllTimers($FormMain)
			Exit

	EndSwitch
WEnd

;---------------------------------------------
; Functions
;---------------------------------------------
Func Initialize()

	;Prfe, ob Job fr diesen Computer vorhanden, ansonsten Abbruch
	If Not FileExists($PATH_JOBS & "\" & @ComputerName & ".ini") then Exit

	;Prfe, ob INIFILE (Konfigurationsdatei)vorhanden ist - falls nicht --> erstellen
	If not FileExists($INIFILE) Then
		MsgBox(48, "ACHTUNG", "Konfigurationsdatei (" & $INIFILE & ") konnte nicht gefunden werden!" & @LF & @LF & "Erzeuge neue Datei...")

		;Erstelle DEFAULT-Schlssel
		IniWrite($INIFILE,"Branding","Label1","Softwareverteilung")
		IniWrite($INIFILE,"Branding","Label2","(c)opyright 2013 Jochen Bierbauer")
		IniWrite($INIFILE,"Branding","Label3","Version X")
		IniWrite($INIFILE,"Branding","image_64x64","logo.bmp")
    EndIf

	$RepositoryPath = IniRead($INIFILE, "Paths","repository", @ScriptDir & "\repository")

EndFunc

Func CallJobs()
	Local $cn, $i,$ii, $arrPackets, $arrCommands, $LogSectionTimestamp = _NowCalc(),$ProgressParts,$conditionValue,$conditionExistent
	$cn = @ComputerName
	$arrPackets = IniReadSection($PATH_JOBS & "\" & $cn & ".ini","Packets")

	; Wenn wir eine Jobdatei mit einer Paketliste fr diesen Computer finden...
	If IsArray($arrPackets) Then

		; Schreibe Logeintrag letzer Status -> O.K. (Bei Eintreffen eines Fehlers, wird der Eintrag spter berschrieben)
		IniWrite($PATH_LOGS & "\" & $cn & ".txt","LastStatus","status","O.K.")
		IniWrite($PATH_LOGS & "\" & $cn & ".txt","LastStatus","FailureTxt","")

		;Progressbareinteilung berechnen
		$ProgressParts = int(100/$arrPackets[0][0])
		_Timer_SetTimer ($FormMain , $PROGRESS_WAIT , "UpdateProgressBar")

		For $i=1 To $arrPackets[0][0]
			;Progressbarmaximalwert berechnen
			$PercentMax = $ProgressParts * $i

			;Globale Variable fr aktiven Datensatz setzen
			$ActivePacket = $arrPackets[$i][0]

			;Schreibe Paketstatus in Jobdatei -> aktuell in Bearbeitung -> actice
			IniWrite($PATH_JOBS & "\" & $cn & ".ini","Packets",$arrPackets[$i][0],"active")

			; Lade Formulardaten
			LoadFormData()

			; Paket nur ausfhren, falls Bedingung erfllt
			$conditionValue    = IniRead($PATH_PACKETS & "\" & $arrPackets[$i][0] & ".ini","condition", "value","")
			$conditionExistent = IniRead($PATH_PACKETS & "\" & $arrPackets[$i][0] & ".ini","condition", "existent","TRUE")
			If $conditionValue == "" Or _
				(CheckCondition($conditionValue) And $conditionExistent == "TRUE" ) Or _
				($conditionValue <> "" And Not CheckCondition($conditionValue) And $conditionExistent == "FALSE" ) Then

				$arrCommands = IniReadSection($PATH_PACKETS & "\" & $arrPackets[$i][0] & ".ini","commands")

				; Wenn wir Commands fr das Paket finden...
				If IsArray($arrCommands) Then

				;Schreibe in Logdatei, dass das Paket ausgefhrt wird/wurde
				IniWrite($PATH_LOGS & "\" & $cn & ".txt", $LogSectionTimestamp,$arrPackets[$i][0], "STARTED")

				For $ii=1 To $arrCommands[0][0]

					; Fhre Befehlszeile aus
					$feedback = RunCommand($arrCommands[$ii][1])
					If StringLen($feedback) >0 Then
						; Es gab ein Problem bei der Ausfhrung
						; Schreibe Logeintrag
						IniWrite($PATH_LOGS & "\" & $cn & ".txt","LastStatus","status","FAILURE")
						IniWrite($PATH_LOGS & "\" & $cn & ".txt","LastStatus","FailureTxt",$feedback)
						IniWrite($PATH_LOGS & "\" & $cn & ".txt", $LogSectionTimestamp,$arrPackets[$i][0],"FAILURE : " & $feedback)
						;Schreibe Paketstatus in Jobdatei
						IniWrite($PATH_JOBS & "\" & $cn & ".ini","Packets",$arrPackets[$i][0],"failure")
						ExitLoop
					Else
						; Befehl wurde ohne Rckmeldung ausgefhrt
						;Schreibe Paketstatus in Jobdatei
						IniWrite($PATH_JOBS & "\" & $cn & ".ini","Packets",$arrPackets[$i][0],"finished")
					EndIf
				Next
			  EndIf
		    Else
				;Schreibe in Logdatei, dass Bedingung fr Paketausfhrung nicht gegeben war
				$feedback = "IGNORED - Condition: " & $conditionValue & " = " & $conditionExistent
				IniWrite($PATH_LOGS & "\" & $cn & ".txt", $LogSectionTimestamp,$arrPackets[$i][0], $feedback)
				;IniWrite($PATH_LOGS & "\" & $cn & ".txt","LastStatus","FailureTxt", " (" & $arrPackets[$i][0] & ") " & $feedback)

				;Schreibe Paketstatus in Jobdatei
				IniWrite($PATH_JOBS & "\" & $cn & ".ini","Packets",$arrPackets[$i][0],"ignored")

			EndIf
			$PercentMax = $PercentMax *2

		Next
		LoadFormData()
		; Lsche Jobdatei
		FileDelete($PATH_JOBS & "\" & $cn & ".ini")
	EndIf
EndFunc


Func LoadFormData()
	Local $cn, $status, $strData = ""
	$cn = @ComputerName
	$arrPackets = IniReadSection($PATH_JOBS & "\" & $cn & ".ini","Packets")

	If IsArray($arrPackets) Then
		GUICtrlSetData($ListPackets,"") ;Liste leeren

		For $i = 1 To $arrPackets[0][0]
			Switch $arrPackets[$i][1]
				Case "open"
					$status = $STAT_OPEN
				Case "failure"
					$status = $STAT_FAILURE
				Case "ignored"
					$status = $STAT_IGNORED
				Case "active"
					$status = $STAT_ACTIVE
				Case "finished"
					$status = $STAT_OK
			EndSwitch

			$strData = $strData & $status & $arrPackets[$i][0] & "|"
		Next
		GUICtrlSetData($ListPackets,$strData,$STAT_ACTIVE & $ActivePacket)
	EndIf
EndFunc

Func CheckCondition($condition)
	;Prft, ob Bedingungseintrag (Datei, Ordner, RegKey, RegKeyValue) wahr ist.

	If StringLen($condition) = 0 Then Return False
	Local $IsRegKey=False, $arr, $erg, $regkey, $regname, $regvalue

	; Prfe, ob es ein Registryeintrag ist.
	; Startet mit "HKEY_LOCAL_MACHINE" ("HKLM") or "HKEY_USERS" ("HKU") or "HKEY_CURRENT_USER" ("HKCU") or "HKEY_CLASSES_ROOT" ("HKCR") or "HKEY_CURRENT_CONFIG" ("HKCC").

	$arr = StringSplit($condition,"\")
	If IsArray($arr) Then
		Switch $arr[1]
			Case "HKEY_LOCAL_MACHINE"
				$IsRegKey=True
			Case "HKLM"
				$IsRegKey=True
			Case "HKEY_USERS"
				$IsRegKey=True
			Case "HKU"
				$IsRegKey=True
			Case "HKEY_CURRENT_USER"
				$IsRegKey=True
			Case "HKCU"
				$IsRegKey=True
			Case "HKEY_CLASSES_ROOT"
				$IsRegKey=True
			Case "HKCR"
				$IsRegKey=True
			Case "HKEY_CURRENT_CONFIG"
				$IsRegKey=True
			Case "HKCC"
				$IsRegKey=True
			Case Else
				$IsRegKey=False
		EndSwitch
	EndIf

	If $IsRegKey Then
		;Prfe ob Regkey vorhanden, oder Regvalue einen Wert hat

		;Wenn ":" vorhanden, ist REG-Name angegeben
		$arr = StringSplit($condition,":")
		If IsArray($arr) And $arr[0] = 2 Then
			$regkey = $arr[1]
			$regname= $arr[2]

			;Wenn "=" vorhanden, ist REG-Wert angegeben
			$arr = StringSplit($regname,"=")
			If IsArray($arr) And $arr[0] = 2 Then
				$regname = $arr[1]
				$regvalue = $arr[2]
			Else
				$regvalue = ""
			EndIf

			;Lese Registry
			$erg = RegRead($regkey,$regname)
			If $erg Then
				If $erg = $regvalue Then
					Return True
				ElseIf $regvalue == "" Then
					Return True
				Else
					Return False
				EndIf
			Else
				Return False
			EndIf

		Else
			Return False
		EndIf

	Else
		;Prfe, ob Datei oder Ordner vorhanden
		If FileExists($condition) Then
			Return True
		Else
			Return False
		EndIf
	EndIf

	Return False

EndFunc

Func RunCommand($cmd)
	Local $pid, $line

	;Ersetze Repositoryplatzhalter durch tatschlichen Pfad
	$cmd = StringReplace($cmd, "%repository%", $RepositoryPath)

	If $cmd <> "NotFound" Then
		;ACHTUNG: Wir benutzen Comspec-Aufruf. Nur hier sind die Pfade fr die Commandbefehle hinterlegt.(z.B. copy etc.)
		; Da der eigentliche Befehl dann innerhalb von Comspec luft (Kindprozess), muss dieser ber "$STDERR_CHILD" abgefragt werden.
		$pid = Run(@ComSpec & " /c " & $cmd , @SystemDir, @SW_HIDE, $STDERR_CHILD)
		;MsgBox(1,"debug", "$PID: " & $PID)

		While 1
			$line = StderrRead($pid)
			If @error Then ExitLoop
			If $line <> "" then
				$line = StringReplace($line,@CRLF," ")
				;MsgBox(48, "F E H L E R:", $line)
				Return $line
			EndIf
		WEnd
	EndIf
	return ""
EndFunc

Func UpdateProgressBar($hWnd, $Msg, $iIDTimer, $dwTime)
    #forceref $hWnd, $Msg, $iIDTimer, $dwTime

	$PercentNow = $PercentNow + 1

	If $PercentNow <= $PercentMax Then
		GUICtrlSetData($Progressbar, $PercentNow)
	Else
		;_Timer_KillAllTimers($FormMain)
	EndIf

EndFunc
